package com.hai.dao;

import com.hai.entity.GoodsLogistics;
import com.hai.entity.GoodsLogisticsExample;
import java.util.List;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface GoodsLogisticsMapper extends GoodsLogisticsMapperExt {
    @SelectProvider(type=GoodsLogisticsSqlProvider.class, method="countByExample")
    long countByExample(GoodsLogisticsExample example);

    @DeleteProvider(type=GoodsLogisticsSqlProvider.class, method="deleteByExample")
    int deleteByExample(GoodsLogisticsExample example);

    @Insert({
        "insert into goods_logistics (user_id, order_id, ",
        "task_no, `number`, ",
        "logistics_status, logistics_status_desc, ",
        "the_last_message, the_last_time, ",
        "take_time, courier, ",
        "courier_phone, logistics_trace_details, ",
        "express_company_name, `status`, ",
        "create_time, op_id, ",
        "op_name, ext_1, ext_2, ",
        "ext_3)",
        "values (#{userId,jdbcType=BIGINT}, #{orderId,jdbcType=BIGINT}, ",
        "#{taskNo,jdbcType=VARCHAR}, #{number,jdbcType=VARCHAR}, ",
        "#{logisticsStatus,jdbcType=VARCHAR}, #{logisticsStatusDesc,jdbcType=VARCHAR}, ",
        "#{theLastMessage,jdbcType=VARCHAR}, #{theLastTime,jdbcType=TIMESTAMP}, ",
        "#{takeTime,jdbcType=VARCHAR}, #{courier,jdbcType=VARCHAR}, ",
        "#{courierPhone,jdbcType=VARCHAR}, #{logisticsTraceDetails,jdbcType=VARCHAR}, ",
        "#{expressCompanyName,jdbcType=VARCHAR}, #{status,jdbcType=INTEGER}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{opId,jdbcType=BIGINT}, ",
        "#{opName,jdbcType=VARCHAR}, #{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, ",
        "#{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(GoodsLogistics record);

    @InsertProvider(type=GoodsLogisticsSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(GoodsLogistics record);

    @SelectProvider(type=GoodsLogisticsSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="order_id", property="orderId", jdbcType=JdbcType.BIGINT),
        @Result(column="task_no", property="taskNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="number", property="number", jdbcType=JdbcType.VARCHAR),
        @Result(column="logistics_status", property="logisticsStatus", jdbcType=JdbcType.VARCHAR),
        @Result(column="logistics_status_desc", property="logisticsStatusDesc", jdbcType=JdbcType.VARCHAR),
        @Result(column="the_last_message", property="theLastMessage", jdbcType=JdbcType.VARCHAR),
        @Result(column="the_last_time", property="theLastTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="take_time", property="takeTime", jdbcType=JdbcType.VARCHAR),
        @Result(column="courier", property="courier", jdbcType=JdbcType.VARCHAR),
        @Result(column="courier_phone", property="courierPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="logistics_trace_details", property="logisticsTraceDetails", jdbcType=JdbcType.VARCHAR),
        @Result(column="express_company_name", property="expressCompanyName", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="op_id", property="opId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_name", property="opName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<GoodsLogistics> selectByExample(GoodsLogisticsExample example);

    @UpdateProvider(type=GoodsLogisticsSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") GoodsLogistics record, @Param("example") GoodsLogisticsExample example);

    @UpdateProvider(type=GoodsLogisticsSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") GoodsLogistics record, @Param("example") GoodsLogisticsExample example);
}